diff --git a/tests/manager/test_all.py b/tests/manager/test_all.py
index bb756887..3d29c922 100644
--- a/tests/manager/test_all.py
+++ b/tests/manager/test_all.py
@@ -1744,106 +1913,483 @@ def test_agenda_month_view_event_outside_timeperiod(app, admin_user, kind):
     assert 'Saturday' in resp.text
 
 
-def test_agenda_view_event(app, manager_user):
-    agenda = Agenda(label='Foo bar')
-    agenda.view_role = manager_user.groups.all()[0]
-    agenda.save()
-    event = Event.objects.create(
-        label='xyz',
-        start_datetime=make_aware(datetime.datetime(2019, 12, 22, 17, 0)),
-        places=10,
-        agenda=agenda,
-    )
-    for i in range(8):
-        booking = Booking.objects.create(event=event)
-        if i < 5:
-            booking.creation_datetime = make_aware(datetime.datetime(2019, 12, 21, 14, 0 + i))
-        if i == 5:
-            booking.creation_datetime = make_aware(datetime.datetime(2019, 12, 21, 15, 0))
-            booking.user_first_name = 'Foo Bar'
-            booking.user_last_name = 'User'
-        if i == 6:
-            booking.creation_datetime = make_aware(datetime.datetime(2019, 12, 21, 16, 0))
-            booking.user_first_name = 'Foo Bar'
-            booking.user_last_name = 'User 2'
-            booking.label = 'Foo Bar Label 2'
-        if i == 7:
-            booking.creation_datetime = make_aware(datetime.datetime(2019, 12, 21, 17, 0))
-            booking.label = 'Foo Bar Label 3'
-        booking.save()
-    Booking.objects.create(event=event, cancellation_datetime=now())
-    app = login(app, username='manager', password='manager')
-    resp = app.get('/manage/agendas/%s/2019/12/' % agenda.id, status=200)
-    resp = resp.click('xyz')
-    assert 'Bookings (8/10): 2 remaining places' in resp.text
-    assert 'Waiting' not in resp.text
-    assert 'This event is overbooked.' not in resp.text
-    assert 'This event is full.' not in resp.text
-    event.waiting_list_places = 5
-    event.save()
-    resp = app.get(resp.request.url)
-    assert 'Waiting List (0/5): 5 remaining places' in resp.text
-    assert 'Anonymous, Dec. 21, 2019, 2 p.m.' in resp.text
-    assert 'Anonymous, Dec. 21, 2019, 2:01 p.m.' in resp.text
-    assert 'Anonymous, Dec. 21, 2019, 2:02 p.m.' in resp.text
-    assert 'Anonymous, Dec. 21, 2019, 2:03 p.m.' in resp.text
-    assert 'Anonymous, Dec. 21, 2019, 2:04 p.m.' in resp.text
-    assert 'Foo Bar User, Dec. 21, 2019, 3 p.m.' in resp.text
-    assert 'Foo Bar User 2, Dec. 21, 2019, 4 p.m.' in resp.text
-    assert 'Foo Bar Label 3, Dec. 21, 2019, 5 p.m.' in resp.text
+def test_agenda_week_view(app, admin_user, manager_user, api_user, get_proper_html_str):
+    agenda = Agenda.objects.create(label='Passeports', kind='meetings')
+    desk = Desk.objects.create(agenda=agenda, label='Desk A')
+    today = datetime.date.today()
 
-    booking = Booking.objects.order_by('pk')[0]
-    booking.in_waiting_list = True
-    booking.save()
-    booking = Booking.objects.order_by('pk')[1]
-    booking.in_waiting_list = True
-    booking.save()
-    resp = app.get(resp.request.url)
-    assert 'Waiting List (2/5): 3 remaining places' in resp.text
-    assert 'Bookings (6/10): 4 remaining places' in resp.text
-    assert list(resp.context['booked']) == list(Booking.objects.order_by('creation_datetime')[2:8])
-    assert list(resp.context['waiting']) == list(Booking.objects.order_by('creation_datetime')[0:2])
+    meetingtype = MeetingType(agenda=agenda, label='passeport', duration=20)
+    meetingtype.save()
 
-    event.places = 5
-    event.save()
-    resp = app.get(resp.request.url)
-    assert 'This event is overbooked.' in resp.text
-    assert 'This event is full.' not in resp.text
+    login(app)
+    resp = app.get('/manage/agendas/%s/%d/%d/%d/' % (agenda.pk, today.year, today.month, today.day))
+    assert 'Week view' in resp.text
+    resp = resp.click('Week view')
+    assert resp.request.url.endswith('%s/week/%s/' % (today.year, today.strftime('%W')))
 
-    event.places = 6
-    event.save()
-    resp = app.get(resp.request.url)
-    assert 'This event is overbooked.' not in resp.text
-    assert 'This event is full.' in resp.text
+    assert 'Day view' in resp.text  # day view link should be present
+    assert 'Month view' in resp.text  # month view link should be present
+    assert 'No opening hours this week.' in resp.text
 
+    today = datetime.date(2018, 11, 10)  # fixed day
+    timeperiod_weekday = today.weekday()
+    timeperiod = TimePeriod(
+        desk=desk, weekday=timeperiod_weekday, start_time=datetime.time(10, 0), end_time=datetime.time(18, 0)
+    )
+    timeperiod.save()
+    app.get('/manage/agendas/%s/%s/%s/' % (agenda.id, today.year, 72), status=404)
+    resp = app.get('/manage/agendas/%s/%s/week/%s/' % (agenda.id, today.year, today.strftime('%W')))
+    assert 'No opening hours this week.' not in resp.text
+    assert '<div class="booking' not in resp.text
+    assert resp.text.count('<tr') == 9
 
-def test_agenda_view_edit_event(app, manager_user):
-    test_agenda_view_event(app, manager_user)
-    agenda = Agenda.objects.first()
-    resp = app.get('/manage/agendas/%s/2019/12/' % agenda.id, status=200)
-    resp = resp.click('xyz')
-    assert 'Options' not in resp.text
-    assert 'Delete' not in resp.text
+    # check opening hours cells
+    assert '<div class="opening-hours" style="height:800.0%;top:0.0%;width:97.0%;left:1.0%' in resp.text
 
-    agenda.edit_role = manager_user.groups.all()[0]
-    agenda.save()
-    event_url = resp.request.url
-    resp = app.get(event_url)
-    assert 'Options' in resp.text
-    resp = resp.click('Options')
-    resp.form['start_datetime_0'] = agenda.event_set.first().start_datetime.strftime('%Y-%m-%d')
-    resp.form['start_datetime_1'] = agenda.event_set.first().start_datetime.strftime('%H:%M')
-    resp = resp.form.submit(status=302).follow()
-    assert event_url == resp.request.url
+    # book some slots
+    app.reset()
+    app.authorization = ('Basic', ('john.doe', 'password'))
+    resp = app.get('/api/agenda/%s/meetings/%s/datetimes/' % (agenda.slug, meetingtype.slug))
+    booking_url = resp.json['data'][0]['api']['fillslot_url']
+    booking_url2 = resp.json['data'][2]['api']['fillslot_url']
+    booking = app.post(booking_url)
+    booking_2 = app.post_json(
+        booking_url2, params={'label': 'foo book', 'user_last_name': "bar's", 'url': 'http://baz/'}
+    )
 
-    resp = resp.click('Delete')
-    resp = resp.form.submit()
-    assert Event.objects.count() == 0
+    app.reset()
+    login(app)
+    date = Booking.objects.all()[0].event.start_datetime
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.id, date.year, date.strftime('%W')))
+    assert resp.text.count('<div class="booking" style="left:1.0%;height:33.0%;') == 2  # booking cells
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[0].text.strip() == 'booked'
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[1].text.strip() == "foo book - bar's"
+    assert get_proper_html_str('foo book - bar&#39;s') in resp
+    assert len(resp.pyquery.find('span.desk')) == 0
 
+    agenda.booking_user_block_template = '<b>{{ booking.user_name }}</b> Foo Bar'
+    agenda.save()
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.id, date.year, date.strftime('%W')))
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[0].text.strip() == '<b></b> Foo Bar'
+    assert resp.pyquery.find('div.booking a').not_('.cancel')[1].text.strip() == "<b>bar's</b> Foo Bar"
+    assert get_proper_html_str('&lt;b&gt;bar&#39;s&lt;/b&gt; Foo Bar') in resp
 
-def test_virtual_agenda_add(app, admin_user):
-    app = login(app)
-    resp = app.get('/manage/', status=200)
+    desk = Desk.objects.create(agenda=agenda, label='Desk B')
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.id, date.year, date.strftime('%W')))
+    assert len(resp.pyquery.find('span.desk')) == 2
+
+    timeperiod = TimePeriod(
+        desk=desk, weekday=timeperiod_weekday, start_time=datetime.time(10, 0), end_time=datetime.time(18, 0)
+    )
+    timeperiod.save()
+
+    app.reset()
+    booking_3 = app.post(booking_url)
+    login(app)
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.id, today.year, today.strftime('%W')))
+
+    # count occurences of timeperiod weekday in current month
+    assert resp.text.count('<div class="opening-hours"') == 2
+    current_month = today.strftime('%Y-%m')
+    if current_month in booking_url or current_month in booking_url2:
+        assert resp.text.count('<div class="booking"') == 3
+
+    # cancel bookings
+    app.reset()
+    app.post(booking.json['api']['cancel_url'])
+    app.post(booking_2.json['api']['cancel_url'])
+    app.post(booking_3.json['api']['cancel_url'])
+
+    # make sure the are not
+    login(app)
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.id, today.year, today.strftime('%W')))
+    assert resp.text.count('<div class="booking"') == 0
+
+    # check December is correctly displayed
+    today = datetime.date(2018, 12, 10)
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.id, today.year, today.strftime('%W')))
+    assert 'No opening hours this week.' not in resp.text
+
+    # display exception
+    unavailability_calendar = UnavailabilityCalendar.objects.create(label='calendar')
+    TimePeriodException.objects.create(
+        label='Calendar exception',
+        unavailability_calendar=unavailability_calendar,
+        start_datetime=make_aware(datetime.datetime(2018, 12, 15, 5, 0)),
+        end_datetime=make_aware(datetime.datetime(2018, 12, 15, 14, 0)),
+    )
+    unavailability_calendar.desks.add(desk)
+    TimePeriodException.objects.create(
+        label='Exception for a December day',
+        desk=desk,
+        start_datetime=make_aware(datetime.datetime(2018, 12, 15, 14, 0)),
+        end_datetime=make_aware(datetime.datetime(2018, 12, 15, 23, 0)),
+    )
+    TimePeriodException.objects.create(
+        label='Exception spanning multiple days',
+        desk=desk,
+        start_datetime=make_aware(datetime.datetime(2018, 12, 11, 14, 0)),
+        end_datetime=make_aware(datetime.datetime(2018, 12, 13, 16, 0)),
+    )
+    with CaptureQueriesContext(connection) as ctx:
+        resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.id, today.year, today.strftime('%W')))
+        assert len(ctx.captured_queries) == 10
+    assert resp.pyquery.find('.exception-hours')[0].attrib == {
+        'class': 'exception-hours',
+        'style': 'height:400.0%;top:400.0%;width:48.0%;left:50.0%;',
+        'title': 'Exception spanning multiple days',
+    }
+    assert resp.pyquery.find('.exception-hours')[1].attrib == {
+        'class': 'exception-hours',
+        'style': 'height:800.0%;top:0.0%;width:48.0%;left:50.0%;',
+        'title': 'Exception spanning multiple days',
+    }
+    assert resp.pyquery.find('.exception-hours')[2].attrib == {
+        'class': 'exception-hours',
+        'style': 'height:600.0%;top:0.0%;width:48.0%;left:50.0%;',
+        'title': 'Exception spanning multiple days',
+    }
+    assert resp.pyquery.find('.exception-hours')[3].attrib == {
+        'class': 'exception-hours',
+        'style': 'height:400.0%;top:0.0%;width:48.0%;left:50.0%;',
+        'title': 'Calendar exception',
+    }
+    assert resp.pyquery.find('.exception-hours')[4].attrib == {
+        'class': 'exception-hours',
+        'style': 'height:400.0%;top:400.0%;width:48.0%;left:50.0%;',
+        'title': 'Exception for a December day',
+    }
+
+
+@pytest.mark.parametrize('kind', ['meetings', 'virtual'])
+def test_agenda_week_view_weekend(app, admin_user, kind):
+    week, year = '02', 2019
+    monday = 0
+    if kind == 'meetings':
+        agenda = Agenda.objects.create(label='Passeports', kind='meetings')
+        desk = Desk.objects.create(agenda=agenda, label='Desk A')
+    else:
+        agenda = Agenda.objects.create(label='Virtual', kind='virtual')
+        real_agenda = Agenda.objects.create(label='Real 1', kind='meetings')
+        VirtualMember.objects.create(virtual_agenda=agenda, real_agenda=real_agenda)
+        desk = Desk.objects.create(agenda=real_agenda, label='New Desk')
+    TimePeriod.objects.create(
+        desk=desk, weekday=monday, start_time=datetime.time(10, 0), end_time=datetime.time(18, 0)
+    )
+
+    login(app)
+    resp = app.get('/manage/agendas/%s/%s/week/%s/' % (agenda.id, year, week))
+    assert 'Sunday' not in resp.text
+    assert 'Saturday' not in resp.text
+    # Month starts a Tuesday, but monday is displayed
+    assert len(resp.pyquery.find('tbody tr:first th.weekday:empty')) == 0
+
+    week, year = 21, 2019  # month starts a Saturday
+    resp = app.get('/manage/agendas/%s/%s/week/%s/' % (agenda.id, year, week))
+    assert len(resp.pyquery.find('tbody tr:first th.weekday:empty')) == 0
+
+    saturday = 5
+    timeperiod_sat = TimePeriod.objects.create(
+        desk=desk, weekday=saturday, start_time=datetime.time(10, 0), end_time=datetime.time(18, 0)
+    )
+    resp = app.get('/manage/agendas/%s/%s/week/%s/' % (agenda.id, year, week))
+    assert 'Sunday' not in resp.text
+    assert 'Saturday' in resp.text
+    assert len(resp.pyquery.find('tbody tr:first th.weekday:empty')) == 0
+
+    sunday = 6
+    TimePeriod.objects.create(
+        desk=desk, weekday=sunday, start_time=datetime.time(10, 0), end_time=datetime.time(18, 0)
+    )
+    resp = app.get('/manage/agendas/%s/%s/week/%s/' % (agenda.id, year, week))
+    assert 'Sunday' in resp.text
+    assert 'Saturday' in resp.text
+
+    timeperiod_sat.delete()
+    resp = app.get('/manage/agendas/%s/%s/week/%s/' % (agenda.id, year, week))
+    assert 'Sunday' in resp.text
+    assert 'Saturday' in resp.text
+
+
+@pytest.mark.parametrize('kind', ['meetings', 'virtual'])
+def test_agenda_week_view_dst_change(app, admin_user, kind):
+    if kind == 'meetings':
+        agenda = Agenda.objects.create(label='Passeports', kind='meetings')
+        desk = Desk.objects.create(agenda=agenda, label='Desk A')
+        meetingtype = MeetingType.objects.create(agenda=agenda, label='passeport', duration=20)
+    else:
+        agenda = Agenda.objects.create(label='Virtual', kind='virtual')
+        real_agenda = Agenda.objects.create(label='Real 1', kind='meetings')
+        VirtualMember.objects.create(virtual_agenda=agenda, real_agenda=real_agenda)
+        desk = Desk.objects.create(agenda=real_agenda, label='New Desk')
+        meetingtype = MeetingType.objects.create(agenda=real_agenda, label='passeport', duration=20)
+
+    for weekday in range(0, 7):  # open all mornings
+        TimePeriod.objects.create(
+            desk=desk, weekday=weekday, start_time=datetime.time(9, 0), end_time=datetime.time(12, 0)
+        )
+
+    login(app)
+    for date in ('2019-10-28', '2019-11-03'):
+        # dst change was on 2019-11-03
+        with freezegun.freeze_time(date):
+            resp = app.get('/manage/agendas/%s/2019/week/43/' % agenda.id)
+            # check all days are correctly aligned
+            assert resp.text.count('height:300.0%;top:0.0%') == 7
+
+    # book some slots
+    for date_tuple in [(2019, 10, 29, 10, 0), (2019, 10, 30, 10, 0)]:
+        event = Event.objects.create(
+            agenda=desk.agenda,
+            places=1,
+            desk=desk,
+            meeting_type=meetingtype,
+            start_datetime=localtime(make_aware(datetime.datetime(*date_tuple))),
+        )
+        Booking.objects.create(event=event)
+
+    # check booked slots are similarly aligned
+    resp = app.get('/manage/agendas/%s/2019/week/43/' % agenda.id)
+    assert resp.text.count('height:33.0%;top:100.0%;') == 2
+
+
+@pytest.mark.parametrize('kind', ['meetings', 'virtual'])
+def test_agenda_week_view_januaries(app, admin_user, kind):
+    if kind == 'meetings':
+        agenda = Agenda.objects.create(label='Passports', kind='meetings')
+        desk = Desk.objects.create(agenda=agenda, label='Desk A')
+        MeetingType.objects.create(agenda=agenda, label='passport', duration=20)
+    else:
+        agenda = Agenda.objects.create(label='Virtual', kind='virtual')
+        real_agenda = Agenda.objects.create(label='Real 1', kind='meetings')
+        VirtualMember.objects.create(virtual_agenda=agenda, real_agenda=real_agenda)
+        desk = Desk.objects.create(agenda=real_agenda, label='New Desk')
+        MeetingType.objects.create(agenda=real_agenda, label='passport', duration=20)
+    TimePeriod(desk=desk, weekday=2, start_time=datetime.time(9, 0), end_time=datetime.time(12, 0)).save()
+
+    for year in range(2020, 2030):
+        date = datetime.date(year, 1, 1)
+        with freezegun.freeze_time(date):
+            login(app)
+            resp = app.get('/manage/agendas/%s/%s/week/01/' % (agenda.id, date.year))
+            assert resp.text.count('<th></th>') == 1
+
+
+@pytest.mark.parametrize('kind', ['meetings', 'virtual'])
+def test_agenda_week_view_event_outside_timeperiod(app, admin_user, kind):
+    middle_day = now().replace(day=15)
+    middle_day = middle_day + datetime.timedelta(days=4 - middle_day.weekday())
+    if kind == 'meetings':
+        agenda = Agenda.objects.create(label='New Example', kind='meetings')
+        desk = Desk.objects.create(agenda=agenda, label='New Desk')
+        meetingtype = MeetingType.objects.create(agenda=agenda, label='Bar', duration=30)
+    else:
+        agenda = Agenda.objects.create(label='Virtual', kind='virtual')
+        real_agenda = Agenda.objects.create(label='Real 1', kind='meetings')
+        VirtualMember.objects.create(virtual_agenda=agenda, real_agenda=real_agenda)
+        desk = Desk.objects.create(agenda=real_agenda, label='New Desk')
+        meetingtype = MeetingType.objects.create(agenda=real_agenda, label='passport', duration=20)
+    login(app)
+
+    # no time period - no events
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.pk, middle_day.year, middle_day.strftime('%W')))
+    assert 'No opening hours this week.' in resp.text
+    assert 'div class="booking' not in resp.text
+
+    # book some slots
+    middle_day = now().replace(day=15)
+    for hour, minute in [(9, 0), (17, 0)]:
+        event = Event.objects.create(
+            agenda=desk.agenda,
+            places=1,
+            desk=desk,
+            meeting_type=meetingtype,
+            start_datetime=localtime(now().replace(day=middle_day.day - middle_day.weekday() + 2)).replace(
+                hour=hour, minute=minute
+            ),
+        )
+        Booking.objects.create(event=event)
+
+    # no time period - events are displayed
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.pk, middle_day.year, middle_day.strftime('%W')))
+    assert resp.text.count('div class="booking') == 2
+
+    # bookings are cancelled
+    Booking.objects.update(cancellation_datetime=now())
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.pk, middle_day.year, middle_day.strftime('%W')))
+    assert 'No opening hours this week.' in resp.text
+    assert resp.text.count('div class="booking') == 0
+
+    # events outside time period
+    Booking.objects.update(cancellation_datetime=None)  # reset
+    TimePeriod.objects.create(
+        desk=desk, weekday=2, start_time=datetime.time(10, 0), end_time=datetime.time(16, 0)
+    )
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.pk, middle_day.year, middle_day.strftime('%W')))
+    assert resp.text.count('div class="booking') == 2
+    assert '<div class="opening-hours" style="height:600.0%;top:100.0%;width:97.0%;left:1.0%' in resp.text
+    assert 'Sunday' not in resp.text
+    assert 'Saturday' not in resp.text
+
+    # create an event on saturday
+    middle_day = now().replace(day=15)
+    middle_day = middle_day + datetime.timedelta(days=5 - middle_day.weekday())
+    event = Event.objects.create(
+        agenda=desk.agenda,
+        places=1,
+        desk=desk,
+        meeting_type=meetingtype,
+        start_datetime=localtime(now()).replace(day=middle_day.day, hour=10, minute=0),
+    )
+    Booking.objects.create(event=event)
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.pk, middle_day.year, middle_day.strftime('%W')))
+    assert resp.text.count('div class="booking') == 3
+    assert 'Sunday' not in resp.text
+    assert 'Saturday' in resp.text
+    # bookings are cancelled
+    Booking.objects.update(cancellation_datetime=now())
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.pk, middle_day.year, middle_day.strftime('%W')))
+    assert resp.text.count('div class="booking') == 0
+    # and a timeperiod
+    Booking.objects.update(cancellation_datetime=None)  # reset
+    TimePeriod.objects.create(
+        desk=desk, weekday=5, start_time=datetime.time(11, 0), end_time=datetime.time(12, 0)
+    )
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.pk, middle_day.year, middle_day.strftime('%W')))
+    assert resp.text.count('div class="booking') == 3
+    assert 'Sunday' not in resp.text
+    assert 'Saturday' in resp.text
+
+    # create an event on sunday
+    middle_day = now().replace(day=15)
+    middle_day = middle_day + datetime.timedelta(days=6 - middle_day.weekday())
+    event = Event.objects.create(
+        agenda=desk.agenda,
+        places=1,
+        desk=desk,
+        meeting_type=meetingtype,
+        start_datetime=localtime(now()).replace(day=middle_day.day, hour=10, minute=0),
+    )
+    Booking.objects.create(event=event)
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.pk, middle_day.year, middle_day.strftime('%W')))
+    assert resp.text.count('div class="booking') == 4
+    assert 'Sunday' in resp.text
+    assert 'Saturday' in resp.text
+    # bookings are cancelled
+    Booking.objects.update(cancellation_datetime=now())
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.pk, middle_day.year, middle_day.strftime('%W')))
+    assert resp.text.count('div class="booking') == 0
+    # and a timeperiod
+    Booking.objects.update(cancellation_datetime=None)  # reset
+    TimePeriod.objects.create(
+        desk=desk, weekday=6, start_time=datetime.time(11, 0), end_time=datetime.time(12, 0)
+    )
+    resp = app.get('/manage/agendas/%s/%d/week/%s/' % (agenda.pk, middle_day.year, middle_day.strftime('%W')))
+    assert resp.text.count('div class="booking') == 4
+    assert 'Sunday' in resp.text
+    assert 'Saturday' in resp.text
+
+
+def test_agenda_view_event(app, manager_user):
+    agenda = Agenda(label='Foo bar')
+    agenda.view_role = manager_user.groups.all()[0]
+    agenda.save()
+    event = Event.objects.create(
+        label='xyz',
+        start_datetime=make_aware(datetime.datetime(2019, 12, 22, 17, 0)),
+        places=10,
+        agenda=agenda,
+    )
+    for i in range(8):
+        booking = Booking.objects.create(event=event)
+        if i < 5:
+            booking.creation_datetime = make_aware(datetime.datetime(2019, 12, 21, 14, 0 + i))
+        if i == 5:
+            booking.creation_datetime = make_aware(datetime.datetime(2019, 12, 21, 15, 0))
+            booking.user_first_name = 'Foo Bar'
+            booking.user_last_name = 'User'
+        if i == 6:
+            booking.creation_datetime = make_aware(datetime.datetime(2019, 12, 21, 16, 0))
+            booking.user_first_name = 'Foo Bar'
+            booking.user_last_name = 'User 2'
+            booking.label = 'Foo Bar Label 2'
+        if i == 7:
+            booking.creation_datetime = make_aware(datetime.datetime(2019, 12, 21, 17, 0))
+            booking.label = 'Foo Bar Label 3'
+        booking.save()
+    Booking.objects.create(event=event, cancellation_datetime=now())
+    app = login(app, username='manager', password='manager')
+    resp = app.get('/manage/agendas/%s/2019/12/' % agenda.id, status=200)
+    resp = resp.click('xyz')
+    assert 'Bookings (8/10): 2 remaining places' in resp.text
+    assert 'Waiting' not in resp.text
+    assert 'This event is overbooked.' not in resp.text
+    assert 'This event is full.' not in resp.text
+    event.waiting_list_places = 5
+    event.save()
+    resp = app.get(resp.request.url)
+    assert 'Waiting List (0/5): 5 remaining places' in resp.text
+    assert 'Anonymous, Dec. 21, 2019, 2 p.m.' in resp.text
+    assert 'Anonymous, Dec. 21, 2019, 2:01 p.m.' in resp.text
+    assert 'Anonymous, Dec. 21, 2019, 2:02 p.m.' in resp.text
+    assert 'Anonymous, Dec. 21, 2019, 2:03 p.m.' in resp.text
+    assert 'Anonymous, Dec. 21, 2019, 2:04 p.m.' in resp.text
+    assert 'Foo Bar User, Dec. 21, 2019, 3 p.m.' in resp.text
+    assert 'Foo Bar User 2, Dec. 21, 2019, 4 p.m.' in resp.text
+    assert 'Foo Bar Label 3, Dec. 21, 2019, 5 p.m.' in resp.text
+
+    booking = Booking.objects.order_by('pk')[0]
+    booking.in_waiting_list = True
+    booking.save()
+    booking = Booking.objects.order_by('pk')[1]
+    booking.in_waiting_list = True
+    booking.save()
+    resp = app.get(resp.request.url)
+    assert 'Waiting List (2/5): 3 remaining places' in resp.text
+    assert 'Bookings (6/10): 4 remaining places' in resp.text
+    assert list(resp.context['booked']) == list(Booking.objects.order_by('creation_datetime')[2:8])
+    assert list(resp.context['waiting']) == list(Booking.objects.order_by('creation_datetime')[0:2])
+
+    event.places = 5
+    event.save()
+    resp = app.get(resp.request.url)
+    assert 'This event is overbooked.' in resp.text
+    assert 'This event is full.' not in resp.text
+
+    event.places = 6
+    event.save()
+    resp = app.get(resp.request.url)
+    assert 'This event is overbooked.' not in resp.text
+    assert 'This event is full.' in resp.text
+
+
+def test_agenda_view_edit_event(app, manager_user):
+    test_agenda_view_event(app, manager_user)
+    agenda = Agenda.objects.first()
+    resp = app.get('/manage/agendas/%s/2019/12/' % agenda.id, status=200)
+    resp = resp.click('xyz')
+    assert 'Options' not in resp.text
+    assert 'Delete' not in resp.text
+
+    agenda.edit_role = manager_user.groups.all()[0]
+    agenda.save()
+    event_url = resp.request.url
+    resp = app.get(event_url)
+    assert 'Options' in resp.text
+    resp = resp.click('Options')
+    resp.form['start_datetime_0'] = agenda.event_set.first().start_datetime.strftime('%Y-%m-%d')
+    resp.form['start_datetime_1'] = agenda.event_set.first().start_datetime.strftime('%H:%M')
+    resp = resp.form.submit(status=302).follow()
+    assert event_url == resp.request.url
+
+    resp = resp.click('Delete')
+    resp = resp.form.submit()
+    assert Event.objects.count() == 0
+
+
+def test_virtual_agenda_add(app, admin_user):
+    app = login(app)
+    resp = app.get('/manage/', status=200)
     resp = resp.click('New')
     resp.form['label'] = 'Virtual agenda'
     resp.form['kind'] = 'virtual'
